"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fileUtil = require("./tool/FileUtil");
var fs = require("fs");
var path = require("path");
var MainJSHX = /** @class */ (function () {
    function MainJSHX(jsUrl, toUrl) {
        this._paramJson = {};
        this._o2nName = {};
        var self = this;
        if (!jsUrl) {
            console.log('没有填写mian.min.js的保存，请重试');
            return;
        }
        self._jsUrl = jsUrl;
        self._toUrl = toUrl || jsUrl;
        self.trans();
    }
    MainJSHX.prototype.trans = function () {
        var self = this;
        fileUtil.FileUtil.walkDir(path.join(this._jsUrl), self.onFile, null, self);
        fs.writeFileSync(path.join(this._toUrl, 'o2nName.json'), JSON.stringify(self._o2nName));
        //转义字符：'\n'：换行符  '\t'：制表符  '\r'：回车
        self._paramJson['chmescape'] = { linefeed: '\n', tab: '\t', enter: '\r' };
        fs.writeFileSync(path.join(this._toUrl, 'jsparam.json'), JSON.stringify(self._paramJson));
    };
    MainJSHX.prototype.onFile = function (url) {
        var type = path.basename(url).split('.')[0];
        var jsStr = fs.readFileSync(url, 'utf-8');
        var paramVal = 'window.cqjsparammap.' + type;
        if (jsStr.indexOf(paramVal) >= 0) {
            console.log(paramVal + '已提取过!!!');
            return;
        }
        var startStr = '(function(){var b=';
        var endStr = '"];function ';
        var startIdx = jsStr.indexOf(startStr);
        if (startIdx == -1) {
            startStr = '(function(){var g=';
            startIdx = jsStr.indexOf(startStr);
        }
        var headStr = jsStr.slice(0, startIdx - 1);
        jsStr = this.glcf(headStr) + ';' + jsStr.slice(startIdx);
        startIdx = jsStr.indexOf(startStr) + startStr.length;
        var endIdx = jsStr.indexOf(endStr) + 1;
        var paramStr = '';
        var char = void 0;
        while (startIdx <= endIdx) {
            char = jsStr[startIdx];
            paramStr += jsStr[startIdx];
            startIdx++;
        }
        this.transJson(paramStr, type);
        jsStr = jsStr.replace(paramStr, paramVal);
        jsStr = this.thfz(jsStr, 'particlesys');
        jsStr = this.thfz(jsStr, 'chm');
        fs.writeFileSync(url.replace(this._jsUrl, this._toUrl), jsStr);
    };
    MainJSHX.prototype.thfz = function (mainjs, name) {
        var namespace = name + '|| (' + name + '= {})';
        var chmIdx = mainjs.indexOf(namespace);
        if (chmIdx >= 0) {
            while (chmIdx--) {
                if (mainjs[chmIdx] == ';') {
                    chmIdx++;
                    mainjs = mainjs.slice(0, chmIdx) + 'ssdgregdsrwetyetjh' + fileUtil.FileUtil.replace(mainjs.slice(chmIdx), namespace, name);
                    mainjs = mainjs.replace('ssdgregdsrwetyetjh', namespace + ';');
                    break;
                }
            }
        }
        return mainjs;
    };
    MainJSHX.prototype.glcf = function (str) {
        var strArr = str.split(',');
        var newStrArr = [];
        for (var i = 0, len = strArr.length; i < len; i++) {
            if (newStrArr.indexOf(strArr[i]) < 0)
                newStrArr.push(strArr[i]);
        }
        var newStr = '';
        for (var j = 0, len = newStrArr.length; j < len; j++) {
            if (newStr)
                newStr += ',';
            newStr += newStrArr[j];
        }
        return newStr;
    };
    MainJSHX.prototype.transJson = function (paramsStr, type) {
        var paramArr = JSON.parse(paramsStr);
        var fiters = ['ChangeJobNewRder', 'BabelRoleRen', 'CrBossHead', 'CrBossRoleRen', 'CrBossRoleRightRen', 'CrossHSFamilyCar', 'CSPlaysetRender', 'CMovieClip', 'CrSandyEnemyView', 'MnRbEui', 'Dispatcher', 'GameEvent', 'SoulTaskRder', 'SXMagicItm'];
        var paramStr;
        var chmArr = [];
        for (var i = 0, len = paramArr.length; i < len; i++) {
            paramStr = paramArr[i];
            if (paramStr.indexOf('chm.') == 0) {
                var subStrArr = paramStr.split('chm.');
                var subStr = subStrArr[1];
                if (fiters.indexOf(subStr) < 0) {
                    chmArr.push(subStr);
                    chmArr.push(paramStr);
                }
            }
        }
        var idx = 0;
        var newName;
        for (var i = 0, len = paramArr.length; i < len; i++) {
            paramStr = paramArr[i];
            if (chmArr.indexOf(paramStr) >= 0) {
                newName = this._o2nName[paramStr];
                if (!newName) {
                    newName = this._o2nName[paramStr] = 'H_F_' + idx;
                    idx++;
                }
                paramArr[i] = newName;
            }
        }
        this._paramJson[type] = paramArr;
    };
    return MainJSHX;
}());
function run(jsUrl, toUrl) {
    new MainJSHX(jsUrl, toUrl);
}
exports.run = run;
